#include <iostream>

using namespace std;
struct Sorte
{
    int x;
    int pocetak;
    int kraj;
    short valid;
};
int main()
{
    long long int n, k;

    int i, j;

    cin>>n>>k;
    int pocetak = 0;
    int kraj = 0;

    Sorte sorta[k+1];

    for(i=0; i<k; i++)
    {
        sorta[i].valid=0;
    }

    for(i=0; i<n; i++)
    {
        int prethodni, broj;
        for (j = 0; j < n; j++)
        {
            cin >> broj;

                if (j == 0)
                {
                    pocetak = j; kraj = j;
                }
                else if (broj == prethodni)
                {
                    kraj = j;
                }
                else
                {
                    if (sorta[prethodni].valid == 0)
                    {
                        sorta[prethodni].kraj = kraj;
                        sorta[prethodni].pocetak = pocetak;
                        sorta[prethodni].valid = 1;
                        sorta[prethodni].x=i;
                    }
                    else if (((sorta[prethodni].pocetak != pocetak) || (sorta[prethodni].kraj != kraj)||(sorta[prethodni].x+1 != i)))
                    {
                        sorta[prethodni].valid = 2;
                    }

                    pocetak = j;
                    kraj = j;
                    sorta[prethodni].x=i;
                }

                if (j == n-1)
                {
                    if (sorta[broj].valid == 0)
                    {
                        sorta[broj].kraj = kraj;
                        sorta[broj].pocetak = pocetak;
                        sorta[broj].valid = 1;
                        sorta[broj].x=i;
                    }
                    else if(((sorta[broj].pocetak != pocetak) || (sorta[broj].kraj != kraj)||(sorta[broj].x+1 != i)))
                    {
                        sorta[broj].valid = 2;
                    }
                    sorta[broj].x=i;
                }
                prethodni = broj;
        }
    }

    long long int brojac=0;

    for (i=0; i<k; i++)
    {
        if (sorta[i].valid == 1)
        {
            brojac++;
        }
    }

    cout<<brojac<<endl;

    return 0;
}